"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = commitizenConfigGenerator;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _pkgManager = _interopRequireDefault(require("../utils/pkgManager"));

function commitizenConfigGenerator() {
  return _commitizenConfigGenerator.apply(this, arguments);
}

function _commitizenConfigGenerator() {
  _commitizenConfigGenerator = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var packageJson;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log(_ansiColors["default"].blue('\nConfiguring Commitizen 🔨 🔨'));
            _context.next = 3;
            return _pkgManager["default"].install(['commitizen', 'cz-conventional-changelog']);

          case 3:
            _context.next = 5;
            return _fsExtra["default"].readJSON('package.json');

          case 5:
            packageJson = _context.sent;
            packageJson.config = {
              commitizen: {
                path: 'cz-conventional-changelog'
              }
            };
            _context.next = 9;
            return _fsExtra["default"].writeJSON('package.json', packageJson, {
              spaces: 2
            });

          case 9:
            _context.next = 11;
            return _pkgManager["default"].runCommand('npm set-script commit "cz"');

          case 11:
            console.log(_ansiColors["default"].blue('Commtizien successfully configured 🎉 🎉'));

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _commitizenConfigGenerator.apply(this, arguments);
}