#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _configurations = require("./configurations");

var _configList = _interopRequireDefault(require("./prompts/config-list.prompt"));

var _fullPackage = _interopRequireDefault(require("./prompts/full-package.prompt"));

var _huskyLintstaged = _interopRequireDefault(require("./generators/husky-lintstaged.generator"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function app() {
  return _app.apply(this, arguments);
}

function _app() {
  _app = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var configs, isFullPackage, _iterator, _step, config, configGenerator;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log(_ansiColors["default"].yellow("\uD83D\uDE80 Setup all linters you like and don't let \uD83D\uDCA9 slip into your code base!\n    \uD83C\uDFAF Eslint\n    \u2728 Stylelint\n    \uD83D\uDED1 Commitlint\n    \uD83D\uDC84 Prettier\n    \uD83D\uDCC3 EditorConfig\n    \uD83D\uDCBB Commitizen\n\n     ".concat(_ansiColors["default"].italic.blue('Will run against'), "\n\n          \uD83D\uDC47\n\n    \uD83D\uDE0D Husky & Lint-Staged \uD83D\uDE0D\n  ")));
            _context.next = 3;
            return (0, _fullPackage["default"])();

          case 3:
            isFullPackage = _context.sent;

            if (!isFullPackage) {
              _context.next = 8;
              break;
            }

            configs = Object.keys(_configurations.availableConfigs);
            _context.next = 11;
            break;

          case 8:
            _context.next = 10;
            return (0, _configList["default"])();

          case 10:
            configs = _context.sent;

          case 11:
            _iterator = _createForOfIteratorHelper(configs);
            _context.prev = 12;

            _iterator.s();

          case 14:
            if ((_step = _iterator.n()).done) {
              _context.next = 21;
              break;
            }

            config = _step.value;
            configGenerator = _configurations.availableConfigs[config];
            _context.next = 19;
            return configGenerator();

          case 19:
            _context.next = 14;
            break;

          case 21:
            _context.next = 26;
            break;

          case 23:
            _context.prev = 23;
            _context.t0 = _context["catch"](12);

            _iterator.e(_context.t0);

          case 26:
            _context.prev = 26;

            _iterator.f();

            return _context.finish(26);

          case 29:
            _context.next = 31;
            return (0, _huskyLintstaged["default"])(configs);

          case 31:
            console.log("".concat(_ansiColors["default"].yellow("".concat(_ansiColors["default"].bold('TA-DAAA'), " \uD83C\uDF89 Enjoy Coding \uD83D\uDC4B"))));

          case 32:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[12, 23, 26, 29]]);
  }));
  return _app.apply(this, arguments);
}

app()["catch"](function (e) {
  console.log(e);
  if (e) console.log(_ansiColors["default"].red('Something went wrong!! 😢'));
});