"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _child_process = require("child_process");

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _shared = require("../prompts/shared");

var defaultInstallOptions = {
  dev: true,
  exact: false
};

var PackageManager = /*#__PURE__*/function () {
  function PackageManager() {
    (0, _classCallCheck2["default"])(this, PackageManager);
    (0, _defineProperty2["default"])(this, "isNpm", this.detectIsUsingNpm());
  }

  (0, _createClass2["default"])(PackageManager, [{
    key: "install",
    value: function () {
      var _install = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(deps) {
        var options,
            _options$dev,
            dev,
            _options$exact,
            exact,
            packages,
            isUsingNpm,
            command,
            _args = arguments;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 1 && _args[1] !== undefined ? _args[1] : defaultInstallOptions;
                _options$dev = options.dev, dev = _options$dev === void 0 ? true : _options$dev, _options$exact = options.exact, exact = _options$exact === void 0 ? false : _options$exact;
                packages = typeof deps === 'string' ? deps : deps.join(' ');
                _context.next = 5;
                return this.isNpm;

              case 5:
                isUsingNpm = _context.sent;

                if (isUsingNpm) {
                  command = ['npm install', dev && '--save-dev', exact && '--save-exact', packages].filter(Boolean).join(' ');
                } else {
                  command = ['yarn add', dev && '--dev', exact && '--exact', packages].filter(Boolean).join(' ');
                }

                console.log("\n\uD83D\uDE80 ".concat((0, _shared.primaryColor)('Installing'), " ").concat(packages, "\n"));
                _context.next = 10;
                return (0, _child_process.execSync)(command, {
                  stdio: 'inherit'
                });

              case 10:
                console.log(_ansiColors["default"].green("\n\u2714 Installed Successfully \uD83D\uDE80 ".concat((0, _shared.primaryColor)(packages), "\n")));

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function install(_x) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: "runCommand",
    value: function () {
      var _runCommand = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(command) {
        var stdout;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _child_process.execSync)(command);

              case 2:
                stdout = _context2.sent;
                return _context2.abrupt("return", stdout.toString());

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function runCommand(_x2) {
        return _runCommand.apply(this, arguments);
      }

      return runCommand;
    }()
  }, {
    key: "detectIsUsingNpm",
    value: function () {
      var _detectIsUsingNpm = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var isYarn;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _fsExtra["default"].pathExists('yarn.lock');

              case 2:
                isYarn = _context3.sent;
                return _context3.abrupt("return", !isYarn);

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function detectIsUsingNpm() {
        return _detectIsUsingNpm.apply(this, arguments);
      }

      return detectIsUsingNpm;
    }()
  }]);
  return PackageManager;
}();

var _default = new PackageManager();

exports["default"] = _default;